// MyModuleInfoDlg.cpp : ʵļ
//

#include "stdafx.h"
#include "ProcessView.h"
#include "MyModuleInfoDlg.h"
#include "afxdialogex.h"
#include <Tlhelp32.h>


// CMyModuleInfoDlg Ի

IMPLEMENT_DYNAMIC(CMyModuleInfoDlg, CDialogEx)

CMyModuleInfoDlg::CMyModuleInfoDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(IDD_DIALOG1, pParent)
{

}

CMyModuleInfoDlg::~CMyModuleInfoDlg()
{
}

void CMyModuleInfoDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialogEx::DoDataExchange(pDX);
    DDX_Control(pDX, LST_MODULE, m_ListCtrl);
}


BEGIN_MESSAGE_MAP(CMyModuleInfoDlg, CDialogEx)
END_MESSAGE_MAP()


// CMyModuleInfoDlg Ϣ



//ýID
void CMyModuleInfoDlg::SetProcessId(DWORD ProcessId)
{
    m_ProcessId = ProcessId;
}


//ȡID
DWORD CMyModuleInfoDlg::GetProcessId() const
{
    return m_ProcessId;
}


//ģϢӵб
void CMyModuleInfoDlg::GetModuleInfo()
{
    //Ľ̿
    HANDLE hSnapshot = CreateToolhelp32Snapshot(TH32CS_SNAPMODULE, m_ProcessId);

    //ȡʧܣֱӷ
    if (INVALID_HANDLE_VALUE == hSnapshot)
    {
        return;
    }

    MODULEENTRY32  me32 = { 0 };
    me32.dwSize = sizeof(MODULEENTRY32);

    //
    if (Module32First(hSnapshot, &me32))
    {
        int nRow = 0;
        CString strFmt;

        do
        {
            //ģ·б
            m_ListCtrl.InsertItem(nRow, me32.szExePath);

            //ģַб
            strFmt.Format(_T("0x%016X"), me32.modBaseAddr);
            m_ListCtrl.SetItemText(nRow, 1, strFmt);

            //ģСб
            strFmt.Format(_T("0x%016X"), me32.modBaseSize);
            m_ListCtrl.SetItemText(nRow, 2, strFmt);

            nRow++;
        } while (Module32Next(hSnapshot, &me32));
    }

    //رվ
    CloseHandle(hSnapshot);
}

BOOL CMyModuleInfoDlg::OnInitDialog()
{
    CDialogEx::OnInitDialog();

    //ListCtrl
    m_ListCtrl.SetExtendedStyle(LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES);

    //ӱͷ
    m_ListCtrl.InsertColumn(0, _T("ģ·"), LVCFMT_LEFT, 370);
    m_ListCtrl.InsertColumn(1, _T("ַ"), LVCFMT_LEFT, 180);
    m_ListCtrl.InsertColumn(2, _T("С"), LVCFMT_LEFT, 180);

    //ģϢӵб
    GetModuleInfo();

    return TRUE;  // return TRUE unless you set the focus to a control
                  // 쳣: OCX ҳӦ FALSE
}
