// MyThreadInfoDlg.cpp : ʵļ
//

#include "stdafx.h"
#include "ProcessView.h"
#include "MyThreadInfoDlg.h"
#include "afxdialogex.h"
#include <Tlhelp32.h>


// CMyThreadInfoDlg Ի

IMPLEMENT_DYNAMIC(CMyThreadInfoDlg, CDialogEx)

CMyThreadInfoDlg::CMyThreadInfoDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(IDD_DIALOG3, pParent)
{
    m_ProcessId = 0;
}

CMyThreadInfoDlg::~CMyThreadInfoDlg()
{
}

void CMyThreadInfoDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialogEx::DoDataExchange(pDX);
    DDX_Control(pDX, LST_THREAD, m_ListCtrl);
}


BEGIN_MESSAGE_MAP(CMyThreadInfoDlg, CDialogEx)
END_MESSAGE_MAP()


// CMyThreadInfoDlg Ϣ


//ʼ


//ýID
void CMyThreadInfoDlg::SetProcessId(DWORD ProcessId)
{
    m_ProcessId = ProcessId;
}


//ȡID
DWORD CMyThreadInfoDlg::GetProcessId() const
{
    return m_ProcessId;
}


//ȡ߳Ϣ,ӵбؼ
void CMyThreadInfoDlg::GetThreadInfo()
{
    //Ľ̿
    HANDLE hSnapshot = CreateToolhelp32Snapshot(TH32CS_SNAPTHREAD, 0);

    //ȡʧܣֱӷ
    if (INVALID_HANDLE_VALUE == hSnapshot)
    {
        return;
    }

    THREADENTRY32  te32 = { 0 };
    te32.dwSize = sizeof(THREADENTRY32);

    //
    if (Thread32First(hSnapshot, &te32))
    {
        int nRow = 0;
        CString strFmt;

        do
        {
            if (m_ProcessId == te32.th32OwnerProcessID)
            {
                //ʾ߳ID
                strFmt.Format(_T("%d"), te32.th32ThreadID);
                m_ListCtrl.InsertItem(nRow, strFmt);

                //ʾ߳ȼ
                strFmt.Format(_T("%d"), te32.tpBasePri);
                m_ListCtrl.SetItemText(nRow, 1, strFmt);

                nRow++;
            }
        } while (Thread32Next(hSnapshot, &te32));
    }
    //رվ
    CloseHandle(hSnapshot);
}


BOOL CMyThreadInfoDlg::OnInitDialog()
{
    CDialogEx::OnInitDialog();

    //ListCtrl
    m_ListCtrl.SetExtendedStyle(LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES);

    //ӱͷ
    m_ListCtrl.InsertColumn(0, _T("߳ID"), LVCFMT_LEFT, 120);
    m_ListCtrl.InsertColumn(1, _T("ȼ"), LVCFMT_LEFT, 250);

    //ȡ߳Ϣ,ӵбؼ
    GetThreadInfo();

    return TRUE;  // return TRUE unless you set the focus to a control
                  // 쳣: OCX ҳӦ FALSE
}
